Loading...
Searching...
No Matches
Sip_content_disposition

## Macros

#define | sip_content_disposition(sip)
| Access a SIP Content-Disposition header structure sip_content_disposition_t from sip_t.
#define | SIP_CONTENT_DISPOSITION_INIT()
| Initializer for structure sip_content_disposition_t.
#define | SIPTAG_CONTENT_DISPOSITION(x)
| Tag list item for pointer to a Content-Disposition header structure sip_content_disposition_t.
#define | SIPTAG_CONTENT_DISPOSITION_REF(x)
| Tag list item for reference to a Content-Disposition header pointer.
#define | SIPTAG_CONTENT_DISPOSITION_STR(s)
| Tag list item for string with Content-Disposition header value.
#define | SIPTAG_CONTENT_DISPOSITION_STR_REF(x)
| Tag list item for reference to a Content-Disposition header string.

## Typedefs

typedef msg_content_disposition_t | sip_content_disposition_t
| @

## Functions

issize_t | sip_content_disposition_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Content-Disposition header.
issize_t | sip_content_disposition_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Content-Disposition header.
sip_content_disposition_t * | sip_content_disposition_init (sip_content_disposition_t x[1])
| Initialize a structure sip_content_disposition_t.
int | sip_is_content_disposition (sip_header_t const *header)
| Test if header object is instance of sip_content_disposition_t.
sip_content_disposition_t * | sip_content_disposition_dup (su_home_t *home, sip_content_disposition_t const *hdr))
| Duplicate a list of Content-Disposition header header structures sip_content_disposition_t.
sip_content_disposition_t * | sip_content_disposition_copy (su_home_t *home, sip_content_disposition_t const *hdr))
| Copy a list of Content-Disposition header header structures sip_content_disposition_t.
sip_content_disposition_t * | sip_content_disposition_make (su_home_t *home, char const *s))
| Make a Content-Disposition header structure sip_content_disposition_t.
sip_content_disposition_t * | sip_content_disposition_format (su_home_t *home, char const *fmt,...)))
| Make a Content-Disposition header from formatting result.

## Variables

msg_hclass_t | sip_content_disposition_class []
| Header class for Content-Disposition header.
tag_typedef_t | siptag_content_disposition
| Tag for Content-Disposition header object.
tag_typedef_t | siptag_content_disposition_str
| Tag for string with Content-Disposition header value.

## Detailed Description

## Macro Definition Documentation

## SIP_CONTENT_DISPOSITION_INIT

#define SIP_CONTENT_DISPOSITION_INIT | ( |  | ) |

Initializer for structure sip_content_disposition_t.

A static sip_content_disposition_t structure for Content-Disposition header must be initialized with the SIP_CONTENT_DISPOSITION_INIT() macro. For instance,

sip_content_disposition_t sip_content_disposition = SIP_CONTENT_DISPOSITION_INIT;
SIP_CONTENT_DISPOSITION_INIT
#define SIP_CONTENT_DISPOSITION_INIT()
Initializer for structure sip_content_disposition_t.
Definition sip_protos.h:15618
sip_content_disposition
#define sip_content_disposition(sip)
Access a SIP Content-Disposition header structure sip_content_disposition_t from sip_t.
Definition sip_protos.h:15601
sip_content_disposition_t
msg_content_disposition_t sip_content_disposition_t
@
Definition sip.h:151

## SIPTAG_CONTENT_DISPOSITION

#define SIPTAG_CONTENT_DISPOSITION | ( |  | x | ) |

Tag list item for pointer to a Content-Disposition header structure sip_content_disposition_t.

The SIPTAG_CONTENT_DISPOSITION() macro is used to include a tag item with a pointer to a sip_content_disposition_t structure in a tag list.

Parameters

  x | pointer to a sip_content_disposition_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_CONTENT_DISPOSITION_REF().

## SIPTAG_CONTENT_DISPOSITION_STR

#define SIPTAG_CONTENT_DISPOSITION_STR | ( |  | s | ) |

Tag list item for string with Content-Disposition header value.

The SIPTAG_CONTENT_DISPOSITION_STR() macro is used to include a tag item with a string containing value of a sip_content_disposition_t header in a tag list.

Parameters

  s | pointer to a string containing Content-Disposition header value, or NULL.

The string in SIPTAG_CONTENT_DISPOSITION_STR() can be converted to a sip_content_disposition_t header structure by giving the string s has second argument to function sip_content_disposition_make().

The corresponding tag taking reference parameter is SIPTAG_CONTENT_DISPOSITION_STR_REF().

## Typedef Documentation

## sip_content_disposition_t

typedef msg_content_disposition_t sip_content_disposition_t

@

The Content-Disposition header field describes how the message body or, in the case of multipart messages, a message body part is to be interpreted by the UAC or UAS. Its syntax is defined in RFC 3261 as follows:

Content-Disposition = "Content-Disposition" HCOLON
disp-type *( SEMI disp-param )
disp-type = "render" / "session" / "icon" / "alert"
/ disp-extension-token
disp-param = handling-param / generic-param
handling-param = "handling" EQUAL
( "optional" / "required"
/ other-handling )
other-handling = token
disp-extension-token = token

The Content-Disposition header was extended by draft-lennox-sip-reg-payload-01.txt section 3.1 as follows:

Content-Disposition = "Content-Disposition" ":"
disposition-type *( ";" disposition-param )
disposition-type = "script" | "sip-cgi" | token
disposition-param = action-param
| modification-date-param
| generic-param
action-param = "action" "=" action-value
action-value = "store" | "remove" | token
modification-date-param = "modification-date" "=" quoted-date-time
quoted-date-time = <"> SIP-date <">

The parsed Content-Disposition header is stored in sip_content_disposition_t structure.

The structure sip_content_disposition_t contains representation of an Content-Disposition header.

The sip_content_disposition_t is defined as follows:

typedef struct msg_content_disposition_s
{
msg_common_t cd_common[1]; // Common fragment info
msg_error_t *cd_next; // Link to next (dummy)
char const *cd_type; // Disposition type
msg_param_t const *cd_params; // List of parameters
char const *cd_handling; // Value of @b handling parameter
unsigned cd_required:1; // True if handling=required
unsigned cd_optional:1; // True if handling=optional
} sip_content_disposition_t;
msg_error_t
struct msg_error_s msg_error_t
msg_common_t
struct msg_common_s msg_common_t
msg_content_disposition_s
msg_content_disposition_s::cd_common
msg_common_t cd_common[1]
msg_content_disposition_s::cd_optional
unsigned cd_optional
msg_content_disposition_s::cd_next
msg_error_t * cd_next
msg_content_disposition_s::cd_type
char const * cd_type
msg_content_disposition_s::cd_required
unsigned cd_required
msg_content_disposition_s::cd_handling
char const * cd_handling
msg_content_disposition_s::cd_params
msg_param_t const * cd_params

## Function Documentation

## sip_content_disposition_copy()

sip_content_disposition_t * sip_content_disposition_copy | ( | su_home_t * | home,
|  | sip_content_disposition_t const * | hdr )

inline

Copy a list of Content-Disposition header header structures sip_content_disposition_t.

The function sip_content_disposition_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  content_disposition = sip_content_disposition_copy(home, sip->sip_content_disposition);
  sip_content_disposition_copy
  sip_content_disposition_t * sip_content_disposition_copy(su_home_t *home, sip_content_disposition_t const *hdr))
  Copy a list of Content-Disposition header header structures sip_content_disposition_t.
  Definition sip_protos.h:15748

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_content_disposition_dup()

sip_content_disposition_t * sip_content_disposition_dup | ( | su_home_t * | home,
|  | sip_content_disposition_t const * | hdr )

inline

Duplicate a list of Content-Disposition header header structures sip_content_disposition_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  content_disposition = sip_content_disposition_dup(home, sip->sip_content_disposition);
  sip_content_disposition_dup
  sip_content_disposition_t * sip_content_disposition_dup(su_home_t *home, sip_content_disposition_t const *hdr))
  Duplicate a list of Content-Disposition header header structures sip_content_disposition_t.
  Definition sip_protos.h:15705

Returns
  A pointer to the newly duplicated sip_content_disposition_t header structure, or NULL upon an error.

## sip_content_disposition_format()

sip_content_disposition_t * sip_content_disposition_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Content-Disposition header from formatting result.

Make a new sip_content_disposition_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_content_disposition_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_content_disposition_init()

sip_content_disposition_t * sip_content_disposition_init | ( | sip_content_disposition_t | x[1] | ) |

inline

Initialize a structure sip_content_disposition_t.

An sip_content_disposition_t structure for Content-Disposition header can be initialized with the sip_content_disposition_init() function/macro. For instance,

sip_content_disposition_t sip_content_disposition;
sip_content_disposition_init(&sip_content_disposition);
sip_content_disposition_init
sip_content_disposition_t * sip_content_disposition_init(sip_content_disposition_t x[1])
Initialize a structure sip_content_disposition_t.
Definition sip_protos.h:15636

## sip_content_disposition_make()

sip_content_disposition_t * sip_content_disposition_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Content-Disposition header structure sip_content_disposition_t.

The function sip_content_disposition_make() makes a new sip_content_disposition_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_content_disposition_t header structure, or NULL upon an error.

## sip_is_content_disposition()

int sip_is_content_disposition | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_content_disposition_t.

Check if the header class is an instance of Content-Disposition header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header content_disposition
  0 | (false) otherwise

## Variable Documentation

## sip_content_disposition_class

msg_hclass_t sip_content_disposition_class[]

extern

Header class for Content-Disposition header.

The header class sip_content_disposition_class defines how a SIP Content-Disposition header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_content_disposition_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.